#include <stdio.h>
#include <bits/stdc++.h>
using namespace std;

int main()
{
    int N, Q;
    long long int a, b, c;
    vector<long long int> p;
    vector<long long int> erat;
    vector<long long int> d;
    vector<long long int> k;
    cin >> N >> Q;
    
    for(long long int i=0; i<N; i++){
        cin >> a >> b;
        d.push_back(a);
        p.push_back(b);
    }
    for(long long int i=0; i<Q; i++){
        cin >> c;
        k.push_back(c);
    }
    
    long long int keks = 0;
    for(long long int i=0; i<d[0]; i++){
        erat.push_back(0);
    }
    for(int i=0; i<N-1; i++){
        keks+=p[i];
        for(long long int j=d[i]; j<d[i+1]; j++){
            if(keks==0){
                erat.push_back(erat[j-1]);
            }else{
                erat.push_back(erat[j-1]+1);
                keks-=1;
            }
        }
    }
    keks+=p[N-1];
    for(long long int i=d[N-1]; i<=k[Q-1]; i++){
        if(keks==0){
            erat.push_back(erat[i-1]);
        }else{
            erat.push_back(erat[i-1]+1);
        }
    }
    
    for(int i=0; i<Q; i++){
        cout << erat[k[i]] << endl;
    }
    
    
    return 0;
}